Graphics 640,480,16,2

;Fruit constants
Const SMILEY = 0
Const CHERRY = 1
Const PEAR = 2
Const BAR = 3
Const MELON = 4
Const STRAWBERRY = 5
Const BELL = 6
Const JACKPOT = 7


;Two cherry wins & smileys fruit wins
;Const TWO_SMILEY_NO_LINE = 20 
Const THREE_SMILEY_NO_LINE# = 0.50 
Const TWO_CHERRYS# = 0.50

;Reels
Const FRUITS_ON_REEL = 19
Const FRUIT_AMOUNT = 7

;Phrase Amount
Const PHRASE_AMOUNT = 5

;Arrays
Dim ReelOneBank(FRUITS_ON_REEL)
Dim ReelTwoBank(FRUITS_ON_REEL)
Dim ReelThreeBank(FRUITS_ON_REEL)
Dim FruitName$(FRUIT_AMOUNT)
Dim ThreeInRowWinAmount#(FRUIT_AMOUNT)

;ClsColor 255,255,255
;Images
;Fruits
Global fruitImages = LoadAnimImage("fruits.png",94,77,0,(FRUIT_AMOUNT+1))
MaskImage fruitImages,255,0,255

;Reel Frame
Global reelFrame=LoadImage("reelFrame.png")

;Buttons
Global holdOneButton = LoadAnimImage("holdbutton.png",120,66,0,2)
Global holdTwoButton = LoadAnimImage("holdbutton.png",120,66,0,2)
Global holdThreeButton = LoadAnimImage("holdbutton.png",120,66,0,2)
Global holdReelOneFrame,holdReelTwoFrame,holdReelThreeFrame
Global startButton = LoadAnimImage("startbutton.png",120,66,0,2)
Global startFrame,startButtonX = (REEL_THREE_X+113)
Global cancelButton = LoadAnimImage("cancelButton.png",120,66,0,2)
Global cancelFrame,cancelButtonX = 1
;Cursor
Global cursor = LoadImage("cursor.png")
Global mx,my,oldmx,oldmy
;dot
Global dot = CreateImage(2,2)
SetBuffer ImageBuffer(dot)
Rect 1,1,1,1

;Fonts
;Digital Font
Const digiFontWidth = 16
Const digiFontHeight = 26
Const digiFontsAvailable = 42
Const digiDisplayX = 105,digiDisplayY = 10
Const digiFonts$ = "0123456789abcdefghijklmnopqrstuvwxyz\-/*|. "
Const blankDigiLine$ = "                          "
Global digiLineMax = Len(blankDigiLine$)+1
Global digiFontImage = LoadAnimImage("digifont.png",16,26,0,50)
MaskImage digiFontImage,255,0,255

;sounds
Global startSpinSound = LoadSound("STARTSPIN.wav")
Global reelstopOneSound = LoadSound("reelstop1.wav")
Global reelstopTwoSound = LoadSound("reelstop2.wav")
Global reelstopThreeSound = LoadSound("reelstop3.wav")
Global winner = LoadSound("winner.wav")
Global holdBeep = LoadSound("HOLD.WAV")
Global holdOneChannel = False,holdTwoChannel = False,holdThreeChannel = False
;Images Constants And Variables
;Misc 
Const REEL_ONE_X=140,REEL_TWO_X = 273,REEL_THREE_X=406
Const TOP_REELS_Y = 110,MID_REELS_Y = 190,BOT_REELS_Y = 270
Global cash# = 10.00
Global cashMax# = cash#
Global bet# = 0.2
Global checksmileysFlag = True
Global reelOnePosition 
Global reelTwoPosition
Global reelThreePosition
Global oldreelOnePos,oldreelTwoPos,oldReelThreePos
Global lastWin$=""
Global bank#=0.0
Global holdReelOneFlag = False
Global holdReelTwoFlag = False
Global holdReelThreeFlag = False
Global holdOneTimer,holdTwoTimer,holdThreeTimer
Global holdX
Global shouldHold
Global holdreel$
Global phraseNumber
;Begin Game
SetupReels()

Global startSpin = False 
Global checkWin = False
Global drawFlag = True 
reelOnePosition = 1
reelTwoPosition = 0
reelThreePosition = 0


SeedRnd(MilliSecs())
SetBuffer BackBuffer()
Repeat
If cash# = 0.0 Then Exit

Cls
DrawBackground()
mx = MouseX()
my = MouseY()

If KeyDown(59)
	SaveBuffer(BackBuffer(),"screenie.bmp")
End If

If ImagesCollide(startButton,startButtonX,390,0,dot,mx,my,0) And MouseHit(1);KeyHit(57)
	PlaySound startSpinSound
	oldreelOnePos = reelOnePosition
	oldreelTwoPos = reelTwoPosition
	oldReelThreePos = reelThreePosition
	checksmileysFlag = True
	If holdReelOneFlag = False
		reelOnePosition = Rand(0,19)
		holdReelOneFrame = 0
	End If
	
	If holdReelTwoFlag = False
		reelTwoPosition = Rand(0,19)
		holdReelTwoFrame = 0
	End If
	
	If holdReelThreeFlag = False
		reelThreePosition = Rand(0,19)
		holdReelThreeFrame = 0
	End If
	
	loop = loop + 1
	cash# = cash# - bet#
	someString$ = cash#
	If someString$ =  "4.60001" 
	 cash# = 4.6 
	End If  
	
	If someString$ = "-1.49012e-007" 
		cash# = 0.0 
	End If 

	
	lastWin$ = ""
	startSpin = True
	checkWin = False
	drawFlag = False
	shouldHold = Rand(0,4)
	startFrame = 0
	oldmx = mx
	oldmy = my
Else
	If MilliSecs() > startTimer + 500 Then 
		startTimer=MilliSecs() ; 'reset' the timer
		startFrame=( startFrame + 1 ) Mod 2
	End If 
End If 
If startSpin = True
	SpinReels() 
	drawFlag = True
	CheckWin = True 
	startSpin = False 
	MoveMouse oldmx,oldmy
End If


If drawFlag = True
	DrawReelOne()
	DrawReelTwo()
	DrawReelThree()
	If checkWin = True
		CheckForWin()
		checkWin = False
		holdReelOneFlag = False
		holdReelTwoFlag = False
		holdReelThreeFlag = False
		holdReelOneFrame = 0
		holdReelTwoFrame = 0
		holdReelThreeFrame = 0
	End If
End If

If shouldHold = 1	
	If ImagesCollide(holdOneButton,REEL_ONE_X-13,390,0,dot,mx,my,0) And MouseDown(1)
		holdReelOneFlag = True
		If ChannelPlaying(holdOneChannel) = False
			holdOneChannel = PlaySound( holdBeep)
		End If 
		holdReelOneFrame = 1
	Else
		If holdReelOneFlag = False
			If MilliSecs() > holdOneTimer + 500 Then 
				holdOneTimer=MilliSecs() ; 'reset' the timer
				holdReelOneFrame=( holdReelOneFrame + 1 ) Mod 2
			End If
		End If 
	End If
	
	If ImagesCollide(holdTwoButton,REEL_TWO_X-13,390,0,dot,mx,my,0) And MouseDown(1)
		holdReelTwoFlag = True
		If ChannelPlaying(holdTwoChannel) = False
			holdTwoChannel = PlaySound( holdBeep)
		End If
		holdReelTwoFrame = 1
	Else
		If holdReelTwoFlag = False
			If MilliSecs() > holdTwoTimer + 500 Then 
				holdTwoTimer=MilliSecs() ; 'reset' the timer
				holdReelTwoFrame=( holdReelTwoFrame + 1 ) Mod 2
			End If
		End If 
	End If

	If ImagesCollide(holdThreeButton,REEL_THREE_X-13,390,0,dot,mx,my,0) And MouseDown(1)
		holdReelThreeFlag = True
		If ChannelPlaying(holdThreeChannel) = False
			holdThreeChannel = PlaySound( holdBeep)
		End If
		holdReelThreeFrame = 1
		Else
		If holdReelThreeFlag = False
			If MilliSecs() > holdThreeTimer + 500 Then 
				holdThreeTimer=MilliSecs() ; 'reset' the timer
				holdReelThreeFrame=( holdReelThreeFrame + 1 ) Mod 2
			End If
		End If 

	End If
	
	If KeyHit(46)
		holdReelOneFlag = False
		holdReelTwoFlag = False
		holdReelThreeFlag = False
		holdReelOneFrame = 0
		holdReelTwoFrame = 0
		holdReelThreeFrame = 0
		holdOneTimer=MilliSecs()
		holdTwoTimer=MilliSecs()
		holdThreeTimer=MilliSecs()
	End If
Else
	holdReelOneFlag = False
	holdReelTwoFlag = False
	holdReelThreeFlag = False 
End If

DrawForeground()
Flip   
If KeyDown(1) Then Exit  
;FlushKeys
Forever 

End 

Function SpinReels()
	reelOneSpinCount = 0
	reelTwoSpinCount = 0
	reelThreeSpinCount = 0
	
	spinReelOne = True
	spinReelTwo = True
	spinReelThree = True
	
	playReelOneSound = True 
	playReelTwoSound = True
	playReelThreeSound = True
	
	spinTimer=MilliSecs()
	
	Repeat
	DrawBackground()
	If MilliSecs() > spinTimer + 100 Then 
		spinTimer=MilliSecs() ; 'reset' the timer
		reelOneSpinCount = reelOneSpinCount + 1
		reelTwoSpinCount = reelTwoSpinCount + 1
		reelThreeSpinCount = reelThreeSpinCount + 1
	End If
	
	If reelOneSpinCount > 3
		If oldReelOnePos = reelOnePosition
			spinReelOne = False
			If holdReelOneFlag = False
				If playreelOneSound = True
					PlaySound reelstopOneSound
					playreelOneSound = False
				End If
			End If			
		End If
	End If
	
	If reelTwoSpinCount > 7
		If oldReelTwoPos = reelTwoPosition
			spinReelTwo = False
			If holdReelTwoFlag = False
				If playReelTwoSound = True
					PlaySound reelstopTwoSound
					playReelTwoSound = False
				End If
			End If
		End If
	End If

	If reelThreeSpinCount > 11
		If oldReelThreePos = reelThreePosition
			spinReelThree = False
			If holdReelThreeFlag = False
				If playReelThreeSound = True
					PlaySound reelstopThreeSound
					playReelThreeSound = False
				End If
			End If 
		End If
	End If
	
	If spinReelOne = True
		If holdReelOneFlag = False
			If oldReelOnePos = 0	;If the reel is on 0
				DrawImage fruitImages,REEL_ONE_X,TOP_REELS_Y,ReelOneBank(19)
			Else
				DrawImage fruitImages,REEL_ONE_X,TOP_REELS_Y,ReelOneBank(oldReelOnePos-1)
			End If
			;Draw Middle
			DrawImage fruitImages,REEL_ONE_X,MID_REELS_Y,ReelOneBank(oldReelOnePos)
			;Draw forwad fruit
			If oldReelOnePos = 19	;If the reel is on 0
				DrawImage fruitImages,REEL_ONE_X,BOT_REELS_Y,ReelOneBank(0)
			Else
				DrawImage fruitImages,REEL_ONE_X,BOT_REELS_Y,ReelOneBank(oldReelOnePos+1)
			End If
			oldReelOnePos = oldReelOnePos - 1
			If oldReelOnePos < 0 Then oldReelOnePos = 19
		Else
			DrawReelOne()
		End If
	Else
		DrawReelOne()
	End If
	
	If spinReelTwo = True
		If holdReelTwoFlag = False
			If oldReelTwoPos = 0	;If the reel is on 0
				DrawImage fruitImages,REEL_TWO_X,TOP_REELS_Y,ReelTwoBank(19)
			Else
				DrawImage fruitImages,REEL_TWO_X,TOP_REELS_Y,ReelTwoBank(oldReelTwoPos-1)
			End If
			;Draw Middle
			DrawImage fruitImages,REEL_TWO_X,MID_REELS_Y,ReelTwoBank(oldReelTwoPos)
			;Draw forwad fruit
			If oldReelTwoPos = 19	;If the reel is on 0
				DrawImage fruitImages,REEL_TWO_X,BOT_REELS_Y,ReelTwoBank(0)
			Else
				DrawImage fruitImages,REEL_TWO_X,BOT_REELS_Y,ReelTwoBank(oldReelTwoPos+1)
			End If
			oldReelTwoPos = oldReelTwoPos - 1
			If oldReelTwoPos < 0 Then oldReelTwoPos = 19
		Else
			DrawReelTwo()
		End If
	Else
		DrawReelTwo()
	End If
	
	If spinReelThree = True
		If holdReelThreeFlag = False
			If oldReelThreePos = 0	;If the reel is on 0
				DrawImage fruitImages,REEL_THREE_X,TOP_REELS_Y,ReelThreeBank(19)
			Else
				DrawImage fruitImages,REEL_THREE_X,TOP_REELS_Y,ReelThreeBank(oldReelThreePos-1)
			End If
			;Draw Middle
			DrawImage fruitImages,REEL_THREE_X,MID_REELS_Y,ReelThreeBank(oldReelThreePos)
			;Draw forwad fruit
			If oldReelThreePos = 19	;If the reel is on 0
				DrawImage fruitImages,REEL_THREE_X,BOT_REELS_Y,ReelThreeBank(0)
			Else
				DrawImage fruitImages,REEL_THREE_X,BOT_REELS_Y,ReelThreeBank(oldReelThreePos+1)
			End If
			oldReelThreePos = oldReelThreePos - 1
			If oldReelThreePos <0 Then oldReelThreePos = 19
		Else
			DrawReelThree()
		End If 
	End If
	DrawForeground()
	Flip
	Until spinReelThree = False
End Function

Function DrawForeground()
	;If cash# <> 10.00
	
	DrawDigiText(blankDigiLine$,0,0) 	
	DrawDigiText(""+FloatToCoinage$(bank#),0,0)
	DrawDigiText(""+FloatToCoinage$(cash#),(20*16),0)
	
	DrawImage reelFrame,REEL_ONE_X-13,TOP_REELS_Y-13
	DrawImage reelFrame,REEL_TWO_X-13,TOP_REELS_Y-13
	DrawImage reelFrame,REEL_THREE_X-13,TOP_REELS_Y-13
	
	DrawImage holdOneButton,REEL_ONE_X-13,390,holdReelOneFrame
	DrawImage holdTwoButton,REEL_TWO_X-13,390,holdReelTwoFrame
	DrawImage holdThreeButton,REEL_THREE_X-13,390,holdReelThreeFrame
	
	;Start button
	DrawImage startButton,startButtonX,390,startFrame
	;Cancel button
	
	DrawImage cancelButton,cancelButtonX,390,holdFrame
	DrawImage dot,mx,my
	DrawImage cursor,mx,my
	;Else
	;	DrawDigiText(blankDigiLine$,0,0) 	
	;	DrawDigiText("tutti-fruity",0,0)
	;End If 
End Function

Function DrawBackground()
	
End Function

Function CheckForWin()
;Check for win
If ReelOneBank(reelOnePosition)=ReelTwoBank(reelTwoPosition)
	If ReelTwoBank(reelTwoPosition)=ReelThreeBank(reelThreePosition)
		bank# = bank# + ThreeInRowWinAmount#(ReelOneBank(reelOnePosition))
		checksmileysFlag = False 
		If ReelOneBank(reelOnePosition) = SMILEY
			shouldhold = 0
		End If
		PlaySound winner
	Else
		If ReelOneBank(reelOnePosition) = CHERRY
			checksmileysFlag = False 
			bank# = bank# + TWO_CHERRYS#
			PlaySound winner
		End If
	End If
End If

;Check for smileys on reels
If checksmileysFlag = True
	smileysOnReels = Checksmileys(reelOnePosition,reelTwoPosition,reelThreePosition)	
	If smileysOnReels = 3
		bank# = bank# + THREE_SMILEY_NO_LINE# 
		lastWin$ = "Three Smiley's won "+THREE_SMILEY_NO_LINE+"p"
		PlaySound winner
	End If
End If 
End Function 

Function DrawReelOne()
;Draw Reel One
If ReelOnePosition = 0	;If the reel is on 0
	DrawImage fruitImages,REEL_ONE_X,TOP_REELS_Y,ReelOneBank(19)
Else
	DrawImage fruitImages,REEL_ONE_X,TOP_REELS_Y,ReelOneBank(reelOnePosition-1)
End If
;Draw Middle
DrawImage fruitImages,REEL_ONE_X,MID_REELS_Y,ReelOneBank(reelOnePosition)
;Draw forwad fruit
If ReelOnePosition = 19	;If the reel is on 0
	DrawImage fruitImages,REEL_ONE_X,BOT_REELS_Y,ReelOneBank(0)
Else
	DrawImage fruitImages,REEL_ONE_X,BOT_REELS_Y,ReelOneBank(reelOnePosition+1)
End If
End Function

Function DrawReelTwo()
;Reel Two
If ReelTwoPosition = 0	;If the reel is on 0 
	DrawImage fruitImages,REEL_TWO_X,TOP_REELS_Y,ReelTwoBank(19) 
Else
	DrawImage fruitImages,REEL_TWO_X,TOP_REELS_Y,ReelTwoBank(reelTwoPosition-1) 
End If
;Draw Middle
DrawImage fruitImages,REEL_TWO_X,MID_REELS_Y,ReelTwoBank(reelTwoPosition) 
;Draw forwad fruit 
If ReelTwoPosition = 19	;If the reel is on 0 
	DrawImage fruitImages,REEL_TWO_X,BOT_REELS_Y,ReelTwoBank(0) 
Else
	DrawImage fruitImages,REEL_TWO_X,BOT_REELS_Y,ReelTwoBank(reelTwoPosition+1) 
End If
End Function

Function DrawReelThree()
;Reel Three
If ReelThreePosition = 0	;If the reel is on 0 
	DrawImage fruitImages,REEL_THREE_X,TOP_REELS_Y,ReelThreeBank(19) 
Else
	DrawImage fruitImages,REEL_THREE_X,TOP_REELS_Y,ReelThreeBank(reelThreePosition-1) 
End If
;Draw Middle
DrawImage fruitImages,REEL_THREE_X,MID_REELS_Y,ReelThreeBank(reelThreePosition) 
;Draw forwad fruit 
If ReelThreePosition = 19	;If the reel is on 0 
	DrawImage fruitImages,REEL_THREE_X,BOT_REELS_Y,ReelThreeBank(0) 
Else
	DrawImage fruitImages,REEL_THREE_X,BOT_REELS_Y,ReelThreeBank(reelThreePosition+1) 
End If
End Function

Function Checksmileys(reelOnePos,reelTwoPos,reelThreePos)
smileysAmount = 0
;check reel One for star

;Check middle
If ReelOneBank(reelOnePos) = SMILEY Then smileysAmount = smileysAmount + 1 
;Check back one
If ReelOnePos = 0	;If the reel is on 0
	If ReelOneBank(19) = SMILEY Then smileysAmount = smileysAmount + 1 ;check array element 19
Else
	If ReelOneBank(reelOnePos-1) = SMILEY Then smileysAmount = smileysAmount + 1 ;Or check back normally 
End If

;Check forward
If ReelOnePos = 19	;If the reel is on 19
	If ReelOneBank(0) = SMILEY Then smileysAmount = smileysAmount + 1 ;check array element 0
Else
	If ReelOneBank(reelOnePos+1) = SMILEY Then smileysAmount = smileysAmount + 1 ;Or check forward normally 
End If

;check reel Two for star

;Check middle
If ReelTwoBank(reelTwoPos) = SMILEY Then smileysAmount = smileysAmount + 1 
;Check back one
If ReelTwoPos = 0	;If the reel is on 0
	If ReelTwoBank(19) = SMILEY Then smileysAmount = smileysAmount + 1 ;check array element 19
Else
	If ReelTwoBank(reelTwoPos-1) = SMILEY Then smileysAmount = smileysAmount + 1 ;Or check back normally 
End If

;Check forward
If ReelTwoPos = 19	;If the reel is on 19
	If ReelTwoBank(0) = SMILEY Then smileysAmount = smileysAmount + 1 ;check array element 0
Else
	If ReelTwoBank(reelTwoPos+1) = SMILEY Then smileysAmount = smileysAmount + 1 ;Or check forward normally 
End If

;Check reel Three for star (If there are more than two smileys counted on previous reels)

If smileysAmount = 2
	;Check middle
	If ReelThreeBank(reelThreePos) = SMILEY Then smileysAmount = smileysAmount + 1 
	;Check back one
	If ReelThreePos = 0	;If the reel is on 0
		If ReelThreeBank(19) = SMILEY Then smileysAmount = smileysAmount + 1 ;check array element 19
	Else
		If ReelThreeBank(reelThreePos-1) = SMILEY Then smileysAmount = smileysAmount + 1 ;Or check back normally 
	End If

	;Check forward
	If ReelThreePos = 19	;If the reel is on 19
		If ReelThreeBank(0) = SMILEY Then smileysAmount = smileysAmount + 1 ;check array element 0
	Else
		If ReelThreeBank(reelThreePos+1) = SMILEY Then smileysAmount = smileysAmount + 1 ;Or check forward normally 
	End If
End If

Return smileysAmount
End Function

Function SetupReels()
	;Setup reel one
	Restore ReelOneData
	For loop = 0 To FRUITS_ON_REEL
		Read reelData
		ReelOneBank(loop) = reelData
	Next

	;Setup reel two
	Restore ReelTwoData
	For loop = 0 To FRUITS_ON_REEL
		Read reelData
		ReelTwoBank(loop) = reelData
	Next

	;Setup reel three
	Restore ReelThreeData
	For loop = 0 To FRUITS_ON_REEL
		Read reelData
		ReelThreeBank(loop) = reelData
	Next

	;Setup fruit names
	Restore ReelFruitNames
	For loop = 0 To FRUIT_AMOUNT
		Read fruitNameData$
		FruitName$(loop) = fruitNameData$
	Next

	;Setup fruit win amounts
	Restore ThreeFruitWinsAmount
	For loop = 0 To FRUIT_AMOUNT
		Read fruitwins#
		ThreeInRowWinAmount#(loop) = fruitwins#
	Next
End Function


;Misc Float Functions
Function FloatToCoinage$(someFloat#)
	;If HasFloatRemainderGotValue(someFloat#)
		someString$ = someFloat#+"0"
	;End If
	Return(someString$)
End Function

Function HasFloatRemainderGotValue(aFloatVariable#)
	tempFloatVariable# = (aFloatVariable#)-(Int(aFloatVariable#))

	If tempFloatVariable# = 0.0
		Return False
	Else
		Return True
	End If
End Function

;Font Function
Function DrawDigiText(textToDraw$,x,y) 
If Len(textToDraw$) > digiLineMax 
	Return(0) 
End If 
image = CreateImage(Len(textToDraw$)*digiFontWidth,digiFontHeight) 
SetBuffer ImageBuffer(image) 
For loopText = 1 To Len(textToDraw$) 
	char$ = Mid$(textToDraw$,loopText,1) 
	For loopDigiFonts = 1 To 49 
		 Digichar$ = Mid$(digiFonts$,loopDigiFonts,1) 
		If DigiChar$ = char$ 
			DrawImage digiFontImage,(loopText-1)*16,0,loopDigiFonts-1 
			Exit
		End If
	Next
Next
SetBuffer BackBuffer()
DrawImage image,(digiDisplayX+x),(digiDisplayY+y)
FreeImage image
Return(1)
End Function
;Data (Obviously)
.ReelOneData
Data 3,0,1,4,2,3,5,2,1,3,2,7,1,2,1,4,0,3,6,2
.ReelTwoData
Data 0,7,1,6,0,5,1,4,1,6,5,3,7,1,6,2,4,1,5,2
.ReelThreeData
Data 0,6,1,2,5,3,1,5,0,6,4,2,7,1,0,1,3,4,1,5
.ReelFruitNames
Data "smiley","cherry","pear","bar","melon","strawberry","bell","jackpot"
.ThreeFruitWinsAmount
Data 0,1.00,1.50,5.00,2.00,3.00,7.00,10.00